/**
 * Copyright © CENRA (2016)
 *
 * remi.clement@espaces-naturels.fr
 * 
 * This software is a multi-platform and portable application based on 
 * the scientifical toolbox to monitor wetlands. With this toolbox it’s 
 * possible to calculate indicators «RhoMéO» to monitor quality, 
 * fonctionalities and urban and agricultural pressures of wetlands. 
 * Indicators are calculated using naturalist data entered and/or imported,
 * and geographic data downloaded from a geographic server.
 * 
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use, 
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info". 
 * 
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability. 
 * 
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or 
 * data to be ensured and,  more generally, to use and operate it in the 
 * same conditions as regards security. 
 * 
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
*/
package fr.cenra.rhomeo.core.data;

import com.fasterxml.jackson.databind.ObjectMapper;
import fr.cenra.rhomeo.api.data.DataContext;
import fr.cenra.rhomeo.api.data.Protocol;
import fr.cenra.rhomeo.api.data.Site;
import fr.cenra.rhomeo.core.RhomeoCore;
import fr.cenra.rhomeo.core.util.SerializableDataContext;
import org.apache.sis.util.ArgumentChecks;
import org.springframework.stereotype.Component;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * Handle data context serialization.
 *
 * @author Cédric Briançon (Geomatys)
 */
@Component
public class DataContextManager {
    private final ObjectMapper jsonMapper;

    public DataContextManager() {
        jsonMapper = new ObjectMapper();
    }

    /**
     * Write data context
     * @param dc Data context to serialize.
     * @throws IOException
     */
    public void writeDataContext(final DataContext dc) throws IOException {
        SerializableDataContext[] contexts = getContexts();
        final SerializableDataContext srDataContext = SerializableDataContext.fromDataContext(dc);
        boolean found = false;
        for (int i=0; i<contexts.length; i++) {
            SerializableDataContext candidate = contexts[i];
            if (candidate.protocolName.equals(srDataContext.protocolName) && candidate.siteName.equals(srDataContext.siteName)) {
                found = true;
                contexts[i] = srDataContext;
                break;
            }
        }
        if (!found) {
            contexts = Arrays.copyOf(contexts, contexts.length + 1);
            contexts[contexts.length - 1] = srDataContext;
        }

        final Path contextsPath = RhomeoCore.DATA_CONTEXT_SITE_PATH;
        if (Files.notExists(contextsPath)) {
            Files.createFile(contextsPath);
        }
        try (final BufferedWriter writer = Files.newBufferedWriter(contextsPath, StandardCharsets.UTF_8)) {
            jsonMapper.writeValue(writer, contexts);
        }
    }

    /**
     * Get the data context for the given site and protocol.
     *
     * @param site Site to consider, must not be {@code null}
     * @param protocol Protocol to consider, must not be {@code null}
     * @return A data context stored previously or {@code null} if not found.
     * @throws IOException
     */
    public SerializableDataContext loadContext(final Site site, final Protocol protocol) throws IOException {
        ArgumentChecks.ensureNonNull("Site", site);
        ArgumentChecks.ensureNonNull("Protocol", protocol);
        final SerializableDataContext[] contexts = getContexts();
        for (final SerializableDataContext context : contexts) {
            if (context.siteName.equals(site.getName()) && context.protocolName.equals(protocol.getName())) {
                return context;
            }
        }
        return null;
    }

    private SerializableDataContext[] getContexts() throws IOException {
        final Path contextsPath = RhomeoCore.DATA_CONTEXT_SITE_PATH;
        if (Files.notExists(contextsPath)) {
            return new SerializableDataContext[0];
        }
        try (final BufferedReader reader = Files.newBufferedReader(contextsPath, StandardCharsets.UTF_8)) {
            return jsonMapper.readValue(reader, SerializableDataContext[].class);
        }
    }

    public void removeReferencesForSite(final String siteName) throws IOException {
        final SerializableDataContext[] contexts = getContexts();
        if (contexts.length == 0) {
            return;
        }

        final List<SerializableDataContext> finalContexts =
                Stream.of(contexts).filter(context -> !context.siteName.equals(siteName))
                                   .collect(Collectors.toList());
        // Something to serialize if we have less contexts in the end
        if (contexts.length != finalContexts.size()) {
            final Path contextsPath = RhomeoCore.DATA_CONTEXT_SITE_PATH;
            try (final BufferedWriter writer = Files.newBufferedWriter(contextsPath, StandardCharsets.UTF_8)) {
                jsonMapper.writeValue(writer, finalContexts.toArray());
            }
        }
    }

    public void updateReferencesSiteName(final String oldName, final String newName) throws IOException {
        final SerializableDataContext[] contexts = getContexts();
        if (contexts.length == 0) {
            return;
        }

        boolean aChange = false;
        final List<SerializableDataContext> finalContexts = new ArrayList<>();
        for (final SerializableDataContext context : contexts) {
            if (context.siteName.equals(oldName)) {
                aChange = true;
                context.siteName = newName;
            }
            finalContexts.add(context);
        }

        // Something to serialize if we have less contexts in the end
        if (aChange) {
            final Path contextsPath = RhomeoCore.DATA_CONTEXT_SITE_PATH;
            try (final BufferedWriter writer = Files.newBufferedWriter(contextsPath, StandardCharsets.UTF_8)) {
                jsonMapper.writeValue(writer, finalContexts.toArray());
            }
        }
    }
}
